---
title: Update an LLM Observability experiment
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > LLM Observability
---

# Update an LLM Observability experiment{% #update-an-llm-observability-experiment %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                                      |
| ----------------- | --------------------------------------------------------------------------------- |
| ap1.datadoghq.com | PATCH https://api.ap1.datadoghq.com/api/v2/llm-obs/v1/experiments/{experiment_id} |
| ap2.datadoghq.com | PATCH https://api.ap2.datadoghq.com/api/v2/llm-obs/v1/experiments/{experiment_id} |
| app.datadoghq.eu  | PATCH https://api.datadoghq.eu/api/v2/llm-obs/v1/experiments/{experiment_id}      |
| app.ddog-gov.com  | PATCH https://api.ddog-gov.com/api/v2/llm-obs/v1/experiments/{experiment_id}      |
| us2.ddog-gov.com  | PATCH https://api.us2.ddog-gov.com/api/v2/llm-obs/v1/experiments/{experiment_id}  |
| app.datadoghq.com | PATCH https://api.datadoghq.com/api/v2/llm-obs/v1/experiments/{experiment_id}     |
| us3.datadoghq.com | PATCH https://api.us3.datadoghq.com/api/v2/llm-obs/v1/experiments/{experiment_id} |
| us5.datadoghq.com | PATCH https://api.us5.datadoghq.com/api/v2/llm-obs/v1/experiments/{experiment_id} |

### Overview

Partially update an existing LLM Observability experiment.

### Arguments

#### Path Parameters

| Name                            | Type   | Description                                 |
| ------------------------------- | ------ | ------------------------------------------- |
| experiment_id [*required*] | string | The ID of the LLM Observability experiment. |

### Request

#### Body Data (required)

Update experiment payload.

{% tab title="Model" %}

| Parent field | Field                        | Type   | Description                                                                                                      |
| ------------ | ---------------------------- | ------ | ---------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]       | object | Data object for updating an LLM Observability experiment.                                                        |
| data         | attributes [*required*] | object | Attributes for updating an LLM Observability experiment.                                                         |
| attributes   | dataset_id                   | string | Updated identifier of the dataset used in this experiment.                                                       |
| attributes   | description                  | string | Updated description of the experiment.                                                                           |
| attributes   | error                        | string | Error message describing why the experiment failed, if applicable.                                               |
| attributes   | metadata                     | object | Updated arbitrary metadata associated with the experiment.                                                       |
| attributes   | name                         | string | Updated name of the experiment.                                                                                  |
| attributes   | status                       | enum   | Execution status of an LLM Observability experiment. Allowed enum values: `running,completed,failed,interrupted` |
| data         | type [*required*]       | enum   | Resource type of an LLM Observability experiment. Allowed enum values: `experiments`                             |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "dataset_id": "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d",
      "description": "string",
      "error": "string",
      "metadata": {},
      "name": "string",
      "status": "completed"
    },
    "type": "experiments"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response containing a single LLM Observability experiment.

| Parent field | Field                         | Type      | Description                                                                                                               |
| ------------ | ----------------------------- | --------- | ------------------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]        | object    | Data object for an LLM Observability experiment.                                                                          |
| data         | attributes [*required*]  | object    | Attributes of an LLM Observability experiment.                                                                            |
| attributes   | aggregate_data                | object    | Pre-computed aggregate metrics for this experiment run, including eval score distributions, token costs, and error rates. |
| attributes   | author                        | object    | User data for the author of an experiment. Only present when `include[user_data]` is `true`.                              |
| author       | email                         | string    | Email address of the user.                                                                                                |
| author       | handle                        | string    | Username or handle associated with the user's Datadog account.                                                            |
| author       | icon                          | string    | URL of the user's icon.                                                                                                   |
| author       | id                            | string    | Unique identifier of the user.                                                                                            |
| author       | name                          | string    | Display name of the user.                                                                                                 |
| attributes   | config [*required*]      | object    | Configuration parameters for the experiment.                                                                              |
| attributes   | created_at [*required*]  | date-time | Timestamp when the experiment was created.                                                                                |
| attributes   | dataset_id [*required*]  | string    | Identifier of the dataset used in this experiment.                                                                        |
| attributes   | dataset_name                  | string    | Name of the dataset used in this experiment. Only present when `include[dataset_names]` is `true`.                        |
| attributes   | dataset_version               | int64     | Version of the dataset used in this experiment.                                                                           |
| attributes   | deleted_at                    | date-time | Timestamp when the experiment was soft-deleted, if applicable.                                                            |
| attributes   | description [*required*] | string    | Description of the experiment.                                                                                            |
| attributes   | error                         | string    | Error message describing why the experiment failed, if applicable.                                                        |
| attributes   | experiment                    | string    | Logical name of the experiment, shared across all runs of the same pipeline.                                              |
| attributes   | metadata [*required*]    | object    | Arbitrary metadata associated with the experiment.                                                                        |
| attributes   | name [*required*]        | string    | Name of the experiment.                                                                                                   |
| attributes   | parent_experiment_id          | string    | Identifier of the parent (baseline) experiment this experiment was run against, if any.                                   |
| attributes   | project_id [*required*]  | string    | Identifier of the project this experiment belongs to.                                                                     |
| attributes   | run_count                     | int32     | Expected number of runs for this experiment.                                                                              |
| attributes   | status                        | enum      | Execution status of an LLM Observability experiment. Allowed enum values: `running,completed,failed,interrupted`          |
| attributes   | updated_at [*required*]  | date-time | Timestamp when the experiment was last updated.                                                                           |
| data         | id [*required*]          | string    | Unique identifier of the experiment.                                                                                      |
| data         | type [*required*]        | enum      | Resource type of an LLM Observability experiment. Allowed enum values: `experiments`                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "aggregate_data": {},
      "author": {
        "email": "jane.doe@example.com",
        "handle": "jane.doe@example.com",
        "icon": "https://example.com/icon.png",
        "id": "00000000-0000-0000-0000-000000000010",
        "name": "Jane Doe"
      },
      "config": {},
      "created_at": "2024-01-15T10:30:00Z",
      "dataset_id": "9f64e5c7-dc5a-45c8-a17c-1b85f0bec97d",
      "dataset_name": "string",
      "dataset_version": "integer",
      "deleted_at": "2019-09-19T10:00:00.000Z",
      "description": "",
      "error": "string",
      "experiment": "my-pipeline",
      "metadata": {},
      "name": "My Experiment v1",
      "parent_experiment_id": "3fd6b5e0-8910-4b1c-a7d0-5b84de329012",
      "project_id": "a33671aa-24fd-4dcd-9b33-a8ec7dde7751",
      "run_count": "integer",
      "status": "completed",
      "updated_at": "2024-01-15T10:30:00Z"
    },
    "id": "3fd6b5e0-8910-4b1c-a7d0-5b84de329012",
    "type": "experiments"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Path parameters export experiment_id="3fd6b5e0-8910-4b1c-a7d0-5b84de329012" \# Curl command curl -X PATCH "https://api.datadoghq.com/api/v2/llm-obs/v1/experiments/${experiment_id}" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "type": "experiments"
  }
}
EOF 
                
##### 

```python
"""
Update an LLM Observability experiment returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.llm_observability_api import LLMObservabilityApi
from datadog_api_client.v2.model.llm_obs_experiment_type import LLMObsExperimentType
from datadog_api_client.v2.model.llm_obs_experiment_update_data_attributes_request import (
    LLMObsExperimentUpdateDataAttributesRequest,
)
from datadog_api_client.v2.model.llm_obs_experiment_update_data_request import LLMObsExperimentUpdateDataRequest
from datadog_api_client.v2.model.llm_obs_experiment_update_request import LLMObsExperimentUpdateRequest

body = LLMObsExperimentUpdateRequest(
    data=LLMObsExperimentUpdateDataRequest(
        attributes=LLMObsExperimentUpdateDataAttributesRequest(),
        type=LLMObsExperimentType.EXPERIMENTS,
    ),
)

configuration = Configuration()
configuration.unstable_operations["update_llm_obs_experiment"] = True
with ApiClient(configuration) as api_client:
    api_instance = LLMObservabilityApi(api_client)
    response = api_instance.update_llm_obs_experiment(experiment_id="experiment_id", body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Update an LLM Observability experiment returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.update_llm_obs_experiment".to_sym] = true
end
api_instance = DatadogAPIClient::V2::LLMObservabilityAPI.new

body = DatadogAPIClient::V2::LLMObsExperimentUpdateRequest.new({
  data: DatadogAPIClient::V2::LLMObsExperimentUpdateDataRequest.new({
    attributes: DatadogAPIClient::V2::LLMObsExperimentUpdateDataAttributesRequest.new({}),
    type: DatadogAPIClient::V2::LLMObsExperimentType::EXPERIMENTS,
  }),
})
p api_instance.update_llm_obs_experiment("experiment_id", body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Update an LLM Observability experiment returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.LLMObsExperimentUpdateRequest{
		Data: datadogV2.LLMObsExperimentUpdateDataRequest{
			Attributes: datadogV2.LLMObsExperimentUpdateDataAttributesRequest{},
			Type:       datadogV2.LLMOBSEXPERIMENTTYPE_EXPERIMENTS,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.UpdateLLMObsExperiment", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewLLMObservabilityApi(apiClient)
	resp, r, err := api.UpdateLLMObsExperiment(ctx, "experiment_id", body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `LLMObservabilityApi.UpdateLLMObsExperiment`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `LLMObservabilityApi.UpdateLLMObsExperiment`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Update an LLM Observability experiment returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.LlmObservabilityApi;
import com.datadog.api.client.v2.model.LLMObsExperimentResponse;
import com.datadog.api.client.v2.model.LLMObsExperimentType;
import com.datadog.api.client.v2.model.LLMObsExperimentUpdateDataAttributesRequest;
import com.datadog.api.client.v2.model.LLMObsExperimentUpdateDataRequest;
import com.datadog.api.client.v2.model.LLMObsExperimentUpdateRequest;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.updateLLMObsExperiment", true);
    LlmObservabilityApi apiInstance = new LlmObservabilityApi(defaultClient);

    LLMObsExperimentUpdateRequest body =
        new LLMObsExperimentUpdateRequest()
            .data(
                new LLMObsExperimentUpdateDataRequest()
                    .attributes(new LLMObsExperimentUpdateDataAttributesRequest())
                    .type(LLMObsExperimentType.EXPERIMENTS));

    try {
      LLMObsExperimentResponse result =
          apiInstance.updateLLMObsExperiment("3fd6b5e0-8910-4b1c-a7d0-5b84de329012", body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling LlmObservabilityApi#updateLLMObsExperiment");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Update an LLM Observability experiment returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_llm_observability::LLMObservabilityAPI;
use datadog_api_client::datadogV2::model::LLMObsExperimentType;
use datadog_api_client::datadogV2::model::LLMObsExperimentUpdateDataAttributesRequest;
use datadog_api_client::datadogV2::model::LLMObsExperimentUpdateDataRequest;
use datadog_api_client::datadogV2::model::LLMObsExperimentUpdateRequest;

#[tokio::main]
async fn main() {
    let body = LLMObsExperimentUpdateRequest::new(LLMObsExperimentUpdateDataRequest::new(
        LLMObsExperimentUpdateDataAttributesRequest::new(),
        LLMObsExperimentType::EXPERIMENTS,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.UpdateLLMObsExperiment", true);
    let api = LLMObservabilityAPI::with_config(configuration);
    let resp = api
        .update_llm_obs_experiment("experiment_id".to_string(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Update an LLM Observability experiment returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.updateLLMObsExperiment"] = true;
const apiInstance = new v2.LLMObservabilityApi(configuration);

const params: v2.LLMObservabilityApiUpdateLLMObsExperimentRequest = {
  body: {
    data: {
      attributes: {},
      type: "experiments",
    },
  },
  experimentId: "experiment_id",
};

apiInstance
  .updateLLMObsExperiment(params)
  .then((data: v2.LLMObsExperimentResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
